#ifndef _STRIX_STORE_API_
#define _STRIX_STORE_API_

#ifdef __cplusplus
extern "C" {
#endif

#include <time.h>

#ifdef _INSIDE_STRIXSTORE
#	define STRIXSTORE_DLL_ENTRY __declspec(dllexport) 
#else
#	define STRIXSTORE_DLL_ENTRY __declspec(dllimport)
#endif

/* =========================== */

struct StrixDB_val 
{
	const char*	datatype; 
	
	union {
		const char* resource;

		struct {
			union {
				int			iVal;
				double		rVal;
				bool		bVal;
				time_t		tVal;
				struct {
					const char*	strVal;	// URI OU texte du literal
					const char* lang;	// pour les literals
				};
				const char*	litVal;
			};
		};
	};
};

/* =========================== */

STRIXSTORE_DLL_ENTRY const char* StrixDB_open(const char* openParameters);
STRIXSTORE_DLL_ENTRY const char* StrixDB_close();

typedef struct lua_State lua_State;
STRIXSTORE_DLL_ENTRY lua_State* StrixDB_lua_State();

STRIXSTORE_DLL_ENTRY const char* StrixDB_exec(const char* cmd, const char** out);


STRIXSTORE_DLL_ENTRY const char* StrixDB_sparql(const char* query, StrixDB_val** triples, int* nbrows, int* nbcols);
void STRIXSTORE_DLL_ENTRY StrixDB_freeMem();

STRIXSTORE_DLL_ENTRY const char* StrixDB_update(const char* query);



#ifdef __cplusplus
};
#endif

#endif /* _STRIX_STORE_API_ */